# frozen_string_literal: true

require 'spec_helper'

RSpec.describe ActiverecordPostgresqlAutoReconnect do
  describe 'postgresql server restarted' do
    it 'resets connection pool' do
      ActiveRecord::Base.establish_connection(
        host: 'localhost',
        port: '5432',
        username: ENV['POSTGRES_USER'],
        password: ENV['POSTGRES_PASSWORD'],
        database: ENV['POSTGRES_DB'],
        adapter: 'postgresql'
      )
      allow_any_instance_of(PG::Connection).to receive(:exec_params).and_raise(
        ActiveRecord::StatementInvalid.new('PG::ConnectionBad')
      )
      expect(ActiveRecord::Base.connection_pool).to receive(:disconnect!)
      expect do
        ActiveRecord::Base.connection.execute('SELECT * FROM information_schema.columns')
      end.to raise_error(ActiveRecord::StatementInvalid)

      allow_any_instance_of(PG::Connection).to receive(:exec_params).and_call_original
    end
  end
end
